﻿using System.Collections.Generic;
using System.Linq;
using System.Text;
using RimWorld;
using RimWorld.Planet;
using UnityEngine;
using Verse;

namespace rjw.MainTab
{
	[StaticConstructorOnStartup]
	public class PawnColumnWorker_IsBreedee : PawnColumnCheckbox
	{
		protected override bool GetDisabled(Pawn pawn)
		{
			return !pawn.CanDesignateBreeding();
		}

		protected override bool GetValue(Pawn pawn)
		{
			return pawn.IsDesignatedBreeding() && xxx.is_human(pawn);
		}

		protected override void SetValue(Pawn pawn, bool value)
		{
			if (value == this.GetValue(pawn)) return;

			pawn.ToggleBreeding();
		}
	}
}